<?php
/*======================================================================*\
|| #################################################################### ||
|| # Advanced attachments check v. 0.1 by PGP, http://www.mcrf.ru     # ||
|| #################################################################### ||
\*======================================================================*/

// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE & ~8192);
@set_time_limit(0);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('CVS_REVISION', '$RCSfile$ - $Revision: 39862 $');
@ini_set('display_errors', 'On');

// #################### PRE-CACHE TEMPLATES AND DATA ######################
$phrasegroups = array('attachment_image');
$specialtemplates = array();

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
require_once(DIR . '/includes/adminfunctions_attachment.php');
require_once(DIR . '/includes/functions_file.php');

// ######################## CHECK ADMIN PERMISSIONS #######################
if (!can_administer('canadminthreads'))
{
	print_cp_no_permission();
}

// ############################# LOG ACTION ###############################
$vbulletin->input->clean_array_gpc('r', array(
	'attachmentid' => TYPE_INT,
	'extension'    => TYPE_STR,
	'attachpath'   => TYPE_STR,
	'dowhat'       => TYPE_STR,
));


log_admin_action(iif($vbulletin->GPC['attachmentid'] != 0, 'attachment id = ' . $vbulletin->GPC['attachmentid'],
				 iif(!empty($vbulletin->GPC['extension']), "extension = " . $vbulletin->GPC['extension'], '')));

// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################

if (!is_dir($vbulletin->options['attachpath'])) {
	die("Attachment directory does not exist!");
}

print_cp_header($vbphrase['pg_afc_grptitle']);

if (empty($_REQUEST['do']))
{
	$_REQUEST['do'] = 'intro';
}

// ###################### Search attachments ####################

$vbulletin->input->clean_array_gpc('r', array(
	'massdelete' => TYPE_STR
));

if ($_REQUEST['do'] == 'search' AND $vbulletin->GPC['massdelete'])
{
	$vbulletin->input->clean_array_gpc('r', array(
		'data_to_delete' => TYPE_ARRAY
	));

	// they hit the mass delete submit button
	if (!is_array($vbulletin->GPC['data_to_delete']))
	{
		// nothing in the array
		define('CP_REDIRECT', 'pg_attachment_fs_check.php');
		print_stop_message('invalid_attachments_specified');
	}
	else
	{
		$_REQUEST['do'] = 'massdelete';
	}
}

// ###################### Actually search attachments ####################
if ($_REQUEST['do'] == 'search')
{
	$vbulletin->input->clean_array_gpc('r', array(
		'search'		=> TYPE_ARRAY,
	));

	if (!$vbulletin->GPC['search']['mode'])
	{
		// nothing to check
		define('CP_REDIRECT', 'pg_attachment_fs_check.php');
		print_stop_message('nothing_to_do');
	}

	$vbulletin->GPC['search']['results'] = intval($vbulletin->GPC['search']['results']);

	if (!$vbulletin->GPC['search']['results'])
	{
		$vbulletin->GPC['search']['results'] = 10;
	}

	$AttachesPath = str_replace('\\', '/', $vbulletin->options['attachpath']);

	// ##### Find attaches in FS which not in posts #####
	if ($vbulletin->GPC['search']['mode'] == 'files_wo_att')
	{
		//Getting all attachments from DB
		
		$query = "
			SELECT
				attachmentid
			FROM " . TABLE_PREFIX . "attachment
		";

		$results = $db->query_read($query);

		$CountAttachesInDB = $db->num_rows($results);

		//Reorganize data for further work and looking for *.attach files
		$AttachesByUserID_Ar = array();

		while ($attach = $vbulletin->db->fetch_array($results))
		{
			$AttachesID_Ar[] = $attach['attachmentid'];
		}

		$FileCountLimit = $vbulletin->GPC['search']['results'];

		function GetDirContent($Path, $AttachesID_Ar, $FileCountLimit, &$FileCount = 0, &$GashFilesList = array())
		{
			$FilePaths = glob($Path . "/*");
			
			foreach($FilePaths as $FilePath)
			{
				if ($FileCount == $FileCountLimit)
				{
				    break;
				}
				if(is_dir($FilePath))
				{
					GetDirContent($FilePath, $AttachesID_Ar, $FileCountLimit, $FileCount, $GashFilesList);
				}
				else
				{
					$FileInfo = pathinfo($FilePath);
					$FileInfo['filesize'] = filesize($FilePath);
					$FileInfo['dateline'] = filemtime($FilePath);
					if (!in_array($FileInfo['filename'], $AttachesID_Ar))
					{
						$FileCount++;
						
						$tmp_array = array();
						$tmp_array['attachmentid'] = 'N/A';
						$tmp_array['filesize'] = $FileInfo['filesize'];
						$tmp_array['dateline'] = $FileInfo['dateline'];
						$tmp_array['counter'] = 'N/A';
						$tmp_array['filename'] = $FileInfo['basename'];
						$tmp_array['username'] = 'N/A';
						$tmp_array['path'] = $FilePath;
						
						$GashFilesList[] = $tmp_array;
					}
				}
			}
			return $GashFilesList;
		}
			
		$FilesOnDiskToDelete_Ar = GetDirContent($AttachesPath, $AttachesID_Ar, $FileCountLimit);

		if (count($FilesOnDiskToDelete_Ar) < 1)
		{
			define('CP_REDIRECT', 'pg_attachment_fs_check.php');
			print_stop_message('no_matches_found');
		}

		$LostAttaches_Ar = $FilesOnDiskToDelete_Ar;
			
		switch ($vbulletin->GPC['search']['orderby'])
		{
			case 'attachment.filename':
				$LostAttaches_Ar_Sort = ($vbulletin->GPC['search']['ordering'] == 'ASC') ? 'sort_filename_asc' : 'sort_filename_desc';
				break;
			case 'attachment.filesize':
				$LostAttaches_Ar_Sort = ($vbulletin->GPC['search']['ordering'] == 'ASC') ? 'sort_filesize_asc' : 'sort_filesize_desc';
				break;
			case 'attachment.dateline':
				$LostAttaches_Ar_Sort = ($vbulletin->GPC['search']['ordering'] == 'ASC') ? 'sort_dateline_asc' : 'sort_dateline_desc';
				break;
		}
		
		function sort_filename_asc  ($a, $b) {if ($a['filename'] == $b['filename']) {return 0;}return ($a['filename'] < $b['filename']) ? -1 : 1;}
		function sort_filename_desc ($a, $b) {if ($a['filename'] == $b['filename']) {return 0;}return ($a['filename'] > $b['filename']) ? -1 : 1;}
		function sort_filesize_asc  ($a, $b) {if ($a['filesize'] == $b['filesize']) {return 0;}return ($a['filesize'] < $b['filesize']) ? -1 : 1;}
		function sort_filesize_desc ($a, $b) {if ($a['filesize'] == $b['filesize']) {return 0;}return ($a['filesize'] > $b['filesize']) ? -1 : 1;}
		function sort_dateline_asc  ($a, $b) {if ($a['dateline'] == $b['dateline']) {return 0;}return ($a['dateline'] < $b['dateline']) ? -1 : 1;}
		function sort_dateline_desc ($a, $b) {if ($a['dateline'] == $b['dateline']) {return 0;}return ($a['dateline'] > $b['dateline']) ? -1 : 1;}
		
		if ($LostAttaches_Ar_Sort)
		{
			uasort($LostAttaches_Ar, $LostAttaches_Ar_Sort);
		}

		$TableHeader = construct_phrase($vbphrase['pg_afc_showing_x_files_no_attachments'], count($FilesOnDiskToDelete_Ar));
		$massdelete_type = 'domassdelete_files';
	}

	// ##### Find attaches in FS which not in posts #####
	if ($vbulletin->GPC['search']['mode'] == 'att_wo_posts')
	{
		//Getting attachments that not have posts from DB
		$query = "
			SELECT
				attachment.attachmentid,
				attachment.userid,
				attachment.filesize,
				attachment.dateline,
				attachment.counter,
				attachment.filename,
				attachment.postid,
				user.username
			FROM " . TABLE_PREFIX . "attachment AS attachment
			LEFT JOIN " . TABLE_PREFIX . "user AS user ON (attachment.userid = user.userid)
			WHERE attachment.postid NOT IN
			(SELECT postid FROM " . TABLE_PREFIX . "post) 
			ORDER BY " . $vbulletin->GPC['search']['orderby'] . " " . $vbulletin->GPC['search']['ordering']." LIMIT ". $vbulletin->GPC['search']['results'] ."
		";

		$results = $db->query_read($query);

		$CountAttachesInDB = $db->num_rows($results);

		if (!$CountAttachesInDB)
		{
			define('CP_REDIRECT', 'pg_attachment_fs_check.php');
			print_stop_message('no_matches_found');
		}

		//Reorganize data for further work and looking for *.attach files
		$LostAttaches_Ar = array();

		while ($attach = $vbulletin->db->fetch_array($results))
		{
			$tmp_array = array();

			$tmp_array['attachmentid'] = $attach['attachmentid'];
			$tmp_array['userid'] = $attach['userid'];
			$tmp_array['filesize'] = $attach['filesize'];
			$tmp_array['dateline'] = $attach['dateline'];
			$tmp_array['counter'] = $attach['counter'];
			$tmp_array['filename'] = $attach['filename'];
			$tmp_array['postid'] = $attach['postid'];
			$tmp_array['username'] = $attach['username'];

			$LostAttaches_Ar[] = $tmp_array;
		}

		$db->free_result($results);

		$TableHeader = construct_phrase($vbphrase['pg_afc_showing_x_attachments_wo_posts'], $CountAttachesInDB);
		$massdelete_type = 'domassdelete_attachments';
	}

	// ##### Find posts which has lost attaches in FS #####
	if ($vbulletin->GPC['search']['mode'] == 'posts_w_lost_att')
	{
		//Getting all attachments from DB
		$query = "
			SELECT
				attachment.attachmentid,
				attachment.userid,
				attachment.filesize,
				attachment.dateline,
				attachment.counter,
				attachment.filename,
				attachment.postid,
				user.username
			FROM " . TABLE_PREFIX . "attachment as attachment
			LEFT JOIN " . TABLE_PREFIX . "user AS user ON (attachment.userid = user.userid)
			ORDER BY " . $vbulletin->GPC['search']['orderby'] . " " . $vbulletin->GPC['search']['ordering']." LIMIT ". $vbulletin->GPC['search']['results'] ."
		";

		$results = $db->query_read($query);

		$CountAttachesInDB = $db->num_rows($results);

		if (!$CountAttachesInDB)
		{
			define('CP_REDIRECT', 'pg_attachment_fs_check.php');
			print_stop_message('no_matches_found');
		}

		//Reorganize data for further work and looking for *.attach files
		$AttachesByUserID_Ar = array();

		while ($attach = $vbulletin->db->fetch_array($results))
		{
			$tmp_array = array();

			$tmp_array['attachmentid'] = $attach['attachmentid'];
			$tmp_array['userid'] = $attach['userid'];
			$tmp_array['filesize'] = $attach['filesize'];
			$tmp_array['dateline'] = $attach['dateline'];
			$tmp_array['counter'] = $attach['counter'];
			$tmp_array['filename'] = $attach['filename'];
			$tmp_array['postid'] = $attach['postid'];
			$tmp_array['username'] = $attach['username'];

			$AttachesByUserID_Ar[$attach['userid']][] = $tmp_array;
		}

		$db->free_result($results);

		$LostAttaches_Ar = array();

		foreach ($AttachesByUserID_Ar as $UserID => $AttachesData)
		{
			$UserID_Str = (string) $UserID;

			foreach ($AttachesData as $SingleAttachData)
			{

				$CurrentAttachPath = $AttachesPath . DIRECTORY_SEPARATOR;

				for ($i = 0; $i < strlen($UserID_Str); $i ++)
				{
					$CurrentAttachPath .= $UserID_Str[$i] . DIRECTORY_SEPARATOR;
				}

				$CurrentAttachPath .= $SingleAttachData['attachmentid']. '.attach';

				if(!realpath($CurrentAttachPath))
				{
					$LostAttaches_Ar[] = $SingleAttachData;
				}
			}
		}

		$TableHeader = construct_phrase($vbphrase['pg_afc_showing_lost_attachments_x_from_y'], count($LostAttaches_Ar),  $CountAttachesInDB);
		$massdelete_type = 'domassdelete_attachments';
	}

	print_form_header('pg_attachment_fs_check', 'search', 0, 1);
	construct_hidden_code('search[results]', $vbulletin->GPC['search']['results']);
	construct_hidden_code('search[mode]', $vbulletin->GPC['search']['mode']);
	construct_hidden_code('search[orderby]', $vbulletin->GPC['search']['orderby']);
	construct_hidden_code('search[ordering]', $vbulletin->GPC['search']['ordering']);	

	print_table_header($TableHeader, 6);

	print_cells_row(array(
		'<input type="checkbox" name="allbox" title="' . $vbphrase['check_all'] . '" onclick="js_check_all(this.form);" />',
		$vbphrase['filename'],
		$vbphrase['username'],
		$vbphrase['date'],
		$vbphrase['filesize'],
		$vbphrase['downloads']
	), 1);

	foreach ($LostAttaches_Ar as $row)
	{
		$row['filesize'] = vb_number_format($row['filesize'], 1, true);
		$cell = array();
		//Checkbox			
		$cell[] = '<input type="checkbox" name="data_to_delete[]" value="'
			.$row['attachmentid'].','
			.$row['postid'].','
			.$row['filename'].','
			.$row['filesize'].','
			.$row['path']
			.'" tabindex="1" />';
			
		//Filename
		if ($vbulletin->GPC['search']['mode'] == 'files_wo_att')
		{
			$cell[] = "<p align=\"$stylevar[left]\">".htmlspecialchars_uni($row['filename']).'<br /><span class="smallfont"><a href=".'.$row['path'].'" target="_blank">'.$row['path'].'</a></span></p>';
		}
		if ($vbulletin->GPC['search']['mode'] == 'att_wo_posts')
		{
			$cell[] = "<p align=\"$stylevar[left]\"><a href=\"../attachment.php?" . $vbulletin->session->vars['sessionurl'] . "attachmentid=$row[attachmentid]&amp;d=$row[dateline]\">" . htmlspecialchars_uni($row['filename']) . '</a></p>';
		}
		if ($vbulletin->GPC['search']['mode'] == 'posts_w_lost_att')
		{
			$cell[] = "<p align=\"$stylevar[left]\">".htmlspecialchars_uni($row['filename']).'</p>';
		}
		
		//Username
		$cell[] = iif($row['userid'], "<a href=\"user.php?" . $vbulletin->session->vars['sessionurl'] . "do=edit&amp;u=$row[userid]\">$row[username]</a>", $row['username']);
		
		//Date
		$cell[] = vbdate($vbulletin->options['dateformat'], $row['dateline']) 
			.iif($row['postid'], construct_link_code($vbphrase['view_post'], "../showpost.php?" . $vbulletin->session->vars['sessionurl'] . "p=$row[postid]", true), '');
		
		//Filesize
		$cell[] = $row['filesize'];
		
		//Download counter
		$cell[] = $row['counter'];
		
		print_cells_row($cell);
	}
	construct_hidden_code('massdelete_type', $massdelete_type);
	print_description_row('<input type="submit" class="button" name="massdelete" value="'.$vbphrase['delete_selected_attachments'].'" tabindex="1" />', 0, 7, '', 'center');
	print_table_footer(6);

}

// ###################### Mass Delete attachments or files confirmation ####################
if ($_REQUEST['do'] == 'massdelete')
{
	$vbulletin->input->clean_array_gpc('r', array(
		'search'			=> TYPE_ARRAY,
		'data_to_delete'	=> TYPE_ARRAY,
		'massdelete_type'	=> TYPE_STR,
	));

	print_form_header('pg_attachment_fs_check', $vbulletin->GPC['massdelete_type']);
	construct_hidden_code('data_to_delete', sign_client_string(serialize($vbulletin->GPC['data_to_delete'])));
	construct_hidden_code('search[results]', $vbulletin->GPC['search']['results']);
	construct_hidden_code('search[mode]', $vbulletin->GPC['search']['mode']);
	construct_hidden_code('search[orderby]', $vbulletin->GPC['search']['orderby']);
	construct_hidden_code('search[ordering]', $vbulletin->GPC['search']['ordering']);
	print_table_header($vbphrase['confirm_deletion']);
	print_description_row($vbphrase['are_you_sure_you_want_to_delete_these_attachments']);
	print_submit_row($vbphrase['yes'], '', 2, $vbphrase['no']);
}

// ###################### Mass Delete files ####################
if ($_POST['do'] == 'domassdelete_files')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'search'				=> TYPE_ARRAY,
		'data_to_delete'		=> TYPE_STR,
	));

	$data_to_delete = @unserialize(verify_client_string($vbulletin->GPC['data_to_delete']));
	
	if ($data_to_delete AND is_array($data_to_delete))
	{
		$files_to_delete_array = array();

		foreach ($data_to_delete as $attach_to_delete_comma)
		{
			$temp_array = explode(',',$attach_to_delete_comma);
			if(file_exists($temp_array[4]))
			{
				unlink($temp_array[4]);
			} 
		}
	}
	
	define('CP_REDIRECT', 'pg_attachment_fs_check.php?do=search&amp;search[results]='.$vbulletin->GPC['search']['results']
			.'&amp;search[mode]='.$vbulletin->GPC['search']['mode']
			.'&amp;search[orderby]='.$vbulletin->GPC['search']['orderby']
			.'&amp;search[ordering]='.$vbulletin->GPC['search']['ordering']);
	print_stop_message('deleted_files_successfully');	
}

// ###################### Mass Delete attachments ####################
if ($_POST['do'] == 'domassdelete_attachments')
{
	$vbulletin->input->clean_array_gpc('p', array(
		'search'				=> TYPE_ARRAY,
		'data_to_delete'		=> TYPE_STR,
	));

	$data_to_delete = @unserialize(verify_client_string($vbulletin->GPC['data_to_delete']));

	if ($data_to_delete AND is_array($data_to_delete))
	{

		$att_ids_array = array();
		$post_ids_array = array();
		$posts_to_edit = array();

		foreach ($data_to_delete as $attach_to_delete_comma)
		{
			$temp_array = explode(',',$attach_to_delete_comma);
			$att_ids_array[]  = $temp_array[0]; //att_id
			$post_ids_array[] = $temp_array[1]; //post_id
			$posts_to_edit[$temp_array[1]][$temp_array[0]]['filename'] = $temp_array[2];
			$posts_to_edit[$temp_array[1]][$temp_array[0]]['filesize'] = $temp_array[3];
		}

		// Adding notices to posts where attaches were
		if ($vbulletin->options['pg_afc_add_notice'] AND ($vbulletin->GPC['search']['mode'] == 'posts_w_lost_att'))
		{
			if (!strpos($vbulletin->options['pg_afc_notice_text'], '{pg_afc_lost_attachment}')) {
				$vbulletin->options['pg_afc_notice_text'] = '[B][COLOR="Red"]Here was attach, but it lost: {pg_afc_lost_attachment}, If you have it, please contact any admin to restore it.[/COLOR][/B]';
			}

			$post_ids = implode(',', $post_ids_array);
			$query = "
				SELECT postid, title, pagetext, visible
				FROM " . TABLE_PREFIX . "post
				WHERE postid IN (". $db->escape_string($post_ids) . ")
			";

			$results = $db->query_read($query);

			$update_query = '';

			while ($post = $vbulletin->db->fetch_array($results))
			{
				if($post['visible'] == 1) 
				{
					$dataman =& datamanager_init('Post', $vbulletin, ERRTYPE_ARRAY, 'threadpost');
					$dataman->set_existing($post);

					$new_pagetext = $post['pagetext'];
					$new_pagetext .= "\r\n";
					foreach ($posts_to_edit[$post['postid']] as $attach_id => $attach_data)
					{
						$notice_text = str_replace('{pg_afc_lost_attachment}', $attach_data['filename'].' ('.$attach_data['filesize'].')', $vbulletin->options['pg_afc_notice_text']);
						$new_pagetext .= "\r\n".$notice_text;
					}

					$dataman->setr('pagetext', $new_pagetext);
					$dataman->pre_save();

					if ($dataman->errors)
					{
						$errors = $dataman->errors;
					}
					if (sizeof($errors) > 0)
					{
						echo construct_errors($errors); exit;
					}
					else
					{
						$dataman->save();
					}
				}
			}

			$db->free_result($results);
		}
		
		// Actually delete attaches
		$ids = implode(',', $att_ids_array);
		$attachdata =& datamanager_init('Attachment', $vbulletin, ERRTYPE_CP);
		$attachdata->condition = "attachmentid IN (-1," . $db->escape_string($ids) . ")";
		$attachdata->log = false;
		$attachdata->delete();
	}

	define('CP_REDIRECT', 'pg_attachment_fs_check.php?do=search&amp;search[results]='.$vbulletin->GPC['search']['results']
			.'&amp;search[mode]='.$vbulletin->GPC['search']['mode']
			.'&amp;search[orderby]='.$vbulletin->GPC['search']['orderby']
			.'&amp;search[ordering]='.$vbulletin->GPC['search']['ordering']);
	print_stop_message('deleted_attachments_successfully');
}

// ###################### Introduction ####################
if ($_REQUEST['do'] == 'intro')
{
	print_form_header('pg_attachment_fs_check', 'search');

	print_table_header($vbphrase['pg_afc_grptitle']);
	print_description_row($vbphrase['pg_afc_action_warning'], 0, 2);	
	print_radio_row($vbphrase['pg_afc_action_select_title'], 'search[mode]', array(
		'files_wo_att' => $vbphrase['pg_afc_action_files_wo_att'],
		'att_wo_posts' => $vbphrase['pg_afc_action_att_wo_posts'],
		'posts_w_lost_att' => $vbphrase['pg_afc_action_posts_w_lost_att']));
	print_label_row($vbphrase['order_by'],'
		<select name="search[orderby]" tabindex="1" class="bginput">
			<option value="user.username">' . $vbphrase['attached_by'] . '</option>
			<option value="attachment.counter">' . $vbphrase['downloads'] . '</option>
			<option value="attachment.filename">' . $vbphrase['filename'] . '</option>
			<option value="attachment.filesize">' . $vbphrase['filesize'] . '</option>
			<option value="attachment.dateline" selected="selected">' . $vbphrase['time'] . '</option>
		</select>
		<select name="search[ordering]" tabindex="1" class="bginput">
			<option value="ASC">' . $vbphrase['ascending'] . '</option>
			<option value="DESC">' . $vbphrase['descending'] . '</option>
		</select>
	', '', 'top', 'orderby');
	print_input_row($vbphrase['pg_afc_att_per_query'], 'search[results]', 50);
	print_submit_row($vbphrase['search'], 0);

	//print_table_footer();
}

print_cp_footer();

?>
